﻿import com.world.*;

// This is just the main class of this demo
// It demonstrates a line that catches on the edges of Lines

// I've put updating of the vectors into the constructors of the Line objects
// If you bugger about with the start and end of a Line other than theta, you must call "updateVector()"
// setEnding automatically does this

class Intersections{
	var surfaces:Array;
	var rope:Array;
	var loop:Number;
	var stage:MovieClip;
	var inter:MovieClip;
	// Constructor
	function Intersections(mc:MovieClip){
		stage = mc;
		inter = _root.inter;
		surfaces = new Array();
		rope = new Array();
		loadSurfaces();
		rope.push(new Line({x:200, y:0}, {x:_xmouse, y:_ymouse}));
		loop = setInterval(this, "main", 40);
	}
	// Main loop
	function main(){
		// Clear the debug drawings
		stage.clear();
		var ropeEnd = rope[rope.length-1];
		ropeEnd.setEnding(_xmouse, _ymouse);
		// Iterate through all of the surfaces
		for (var i = 0; i < surfaces.length; i++) {
			var wall = surfaces[i];
			// Are we below the platform?
			if(ropeEnd.p1.y > surfaces[i].p1.y){
				// is the platform below the last rope point? if not, skip this surface
				if(ropeEnd.p0.y >= surfaces[i].p1.y){
					continue;
				}
				// Get the intersection point
				var ip = Vector.intersectionPoint(ropeEnd, surfaces[i]);
				// is it on the platform? if so, add it to the rope array
				if(ip.x > surfaces[i].p0.x && ip.x < surfaces[i].p1.x){
					// Get midpoint
					var midpointX = surfaces[i].p0.x + surfaces[i].len * 0.5;
					// force intersection point to edge and define the UNSTICK ZONE!!!!
					if(ip.x <= midpointX){
						// LEFT SIDE - force to edge - recalculate theta and unstick zones
						ip.x = surfaces[i].p0.x;
						ropeEnd.setEnding(ip.x, ip.y);
						ropeEnd.minTheta = ropeEnd.theta;
						ropeEnd.maxTheta = ropeEnd.theta + Math.PI;
					}else{
						// RIGHT SIDE - force to edge - recalculate theta and unstick zones
						ip.x = surfaces[i].p1.x;
						ropeEnd.setEnding(ip.x, ip.y);
						ropeEnd.minTheta = ropeEnd.theta - Math.PI;
						ropeEnd.maxTheta = ropeEnd.theta;
					}
					// Add to the rope array
					rope.push(new Line({x:ropeEnd.p1.x, y:ropeEnd.p1.y},{x:stage._xmouse, y:stage._ymouse}));
					ropeEnd = rope[rope.length-1];
				}
				// debug spot of where the intersection point is
				inter._x = ip.x;
				inter._y = ip.y;
			}
			
		}
		// Unstick rope check
		if(rope.length > 1){
			if(ropeEnd.theta > rope[rope.length-2].minTheta && ropeEnd.theta < rope[rope.length-2].maxTheta){
				ropeEnd = rope[rope.length-2];
				rope.pop();
			}
			// Hack to deal with the whole radians thing going from -PI to PI in one degree
			if(rope[rope.length-2].maxTheta > Math.PI && ropeEnd.theta + Math.PI < rope[rope.length-2].minTheta){
				ropeEnd = rope[rope.length-2];
				rope.pop();
			}
		}
		drawSurfaces();
		drawRope();
	}
	function drawSurfaces(){
		for(var i = 0; i < surfaces.length; i++){
			var s = surfaces[i];
			stage.lineStyle(2, 0x119911);
			stage.moveTo(s.p0.x, s.p0.y);
			stage.lineTo(s.p1.x, s.p1.y);
		}
	}
	function drawRope(){
		for(var i = 0; i < rope.length; i++){
			var r = rope[i];
			stage.lineStyle(2, 0);
			stage.moveTo(r.p0.x, r.p0.y);
			stage.lineTo(r.p1.x, r.p1.y);
		}
	}
	function loadSurfaces(){
		surfaces.push(new Line({x:51, y:86}, {x:115, y:86}));
		surfaces.push(new Line({x:118, y:123}, {x:181, y:123}));
		surfaces.push(new Line({x:234, y:80}, {x:302, y:80}));
		surfaces.push(new Line({x:190, y:185}, {x:293, y:185}));
		surfaces.push(new Line({x:72, y:223}, {x:150, y:223}));
		surfaces.push(new Line({x:139, y:273}, {x:346, y:273}));
		surfaces.push(new Line({x:51, y:327}, {x:159, y:327}));
		surfaces.push(new Line({x:97, y:361}, {x:177, y:361}));
		surfaces.push(new Line({x:138, y:397}, {x:190, y:397}));
		surfaces.push(new Line({x:54, y:432}, {x:232, y:432}));
		surfaces.push(new Line({x:242, y:366}, {x:340, y:366}));
		surfaces.push(new Line({x:246, y:334}, {x:317, y:334}));
		surfaces.push(new Line({x:173, y:494}, {x:360, y:494}));
		surfaces.push(new Line({x:60, y:535}, {x:151, y:535}));
		surfaces.push(new Line({x:234, y:537}, {x:313, y:537}));
		surfaces.push(new Line({x:40, y:169}, {x:149, y:169}));
		surfaces.push(new Line({x:165, y:45}, {x:307, y:45}));
		surfaces.push(new Line({x:255, y:226}, {x:352, y:226}));
		surfaces.push(new Line({x:197, y:304}, {x:232, y:304}));
		surfaces.push(new Line({x:268, y:306}, {x:330, y:306}));
		surfaces.push(new Line({x:214, y:455}, {x:335, y:455}));
	}
}