﻿import com.world.*;

// Vector class for calculation of positions and directions

class com.world.Vector{
	var p0:Object;// 	Old position x,y
	var p1:Object;// 	Current position x,y
	var vx:Number;// 	distance between p0.x and p1.x
	var vy:Number;// 	distance between p0.y and p1.y
	var len:Number;// 	vector length (pythagoras length of p0 to p1)
	var dx:Number;// 	x value of unit vector (equal to Math.cos(theta))
	var dy:Number;// 	y value of unit vector (equal to Math.sin(theta))
	var rx:Number;// 	x value of right hand unit vector
	var ry:Number;// 	y value of right hand unit vector
	var lx:Number;// 	x value of left hand unit vector
	var ly:Number;// 	y value of left hand unit vector
	var theta:Number;//	the angle of this vector
	// Empty constructor
	function Vector(){
		p0 = new Object();
		p1 = new Object();
	}
	// Initialise Vector
	function updateVector() {
		var v = this;
		var frompoints = true;
		// x and y components
		if (frompoints) {
			v.vx = v.p1.x - v.p0.x;
			v.vy = v.p1.y - v.p0.y;
		} else {
			v.p1.x = v.p0.x + v.vx;
			v.p1.y = v.p0.y + v.vy;
		}
		// length of vector
		v.len = Math.sqrt(v.vx * v.vx + v.vy * v.vy);
		// normalized unit-sized components
		if (v.len > 0) {
			v.dx = v.vx / v.len;
			v.dy = v.vy / v.len;
		} else {
			v.dx = 0;
			v.dy = 0;
		}
		// right hand normal
		v.rx = -v.dy;
		v.ry = v.dx;
		// left hand normal
		v.lx = v.dy;
		v.ly = -v.dx;
		v.theta = Math.atan2(v.vy, v.vx);
		return v;
	}
	// Perpendicular product (whatever that is)
	static function perP(va, vb):Number{
		var pp = va.vx*vb.vy - va.vy*vb.vx;
		return pp;
	}
	// Returns a point on the same line as the surface you are projecting on to
	static function intersectionPoint(v1:Vector, v2:Vector){
		var v3={vx:v2.p0.x-v1.p0.x, vy:v2.p0.y-v1.p0.y};
		var t=perP(v3, v2)/perP(v1, v2);
		var ip={};
		ip.x=v1.p0.x+v1.vx*t;
		ip.y=v1.p0.y+v1.vy*t;
		return ip;
	}
}